#include <alloc.h>
#include <dir.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include <sys/stat.h>
#include <process.h>
#include "execute.h"
#include "tools.h"
#include "define.h"
#include "buffers.h"
#include "node.h"
#include "protocole.h"
#include "database.h"

#define STDOUT 1


/*Acceder a une base de donnees de type BuckMaster*/
int EXECUTE_buckMaster(int nUserStream, char * Cmd, char * Args, char * Path, int Remote)
{
  struct stat bufstat;
  char	sBuffer[MAXPATH+256];
  char *pTmpFile;
  char  sCmd[256];
  char *pPtr;
  int	ExitCode;
  FILE *fPtr;

  //Enlever CRLF de la commande
  strcpy(sCmd, Cmd);
  TOOLS_removeNR(sCmd);

  //Remplacer les '/' par des '\'
  pPtr = sCmd;
  while( *pPtr )
  {
    if( *pPtr == '/' )
      *pPtr = '\\';
    pPtr++;
  }

  //Quitter si Cmd commence par un '*' ou un '*' (car stat considre un tel fichier comme existant)
  if( *sCmd == '?' || *sCmd == '*' )
    return -1;

  //Crer le nom du fichier (.EXE)
  sprintf(sBuffer, "%s%s.exe", Path, sCmd);

  //Ce programme existe t-il (.EXE) ?
  if( (stat(sBuffer, &bufstat) == -1) )
  {
    //Peut-tre un .BAT ?
    sprintf(sBuffer, "%s%s.bat", Path, sCmd);

    //Ce programme existe t-il (.BAT) ?
    if( (stat(sBuffer, &bufstat) == -1) )
      return -1;
  }

  //Le fichier existe - Ajouter les arguments
  strcat(sBuffer, " ");
  strcat(sBuffer, Args);

  //Prparer le fichier temporaire
  pTmpFile = tempnam("/tmp", "dx");

  //Excuter la commande
  ExitCode = EXECUTE_dos(sBuffer, pTmpFile);

  if( ExitCode == 127 )
    ExitCode = -1;

  //Renvoyer le retour  l'utilisateur
  if( (ExitCode >= 0) && (fPtr = fopen(pTmpFile, "rt")) != 0 )
  {
    char szServer[16];
    extern char * DATABASE_pszRemoteDB_FromPC;

    NODE_getNodeCall(0, 0, szServer);	/*Indicatif du serveur - Remote DB*/

    for(;;)
    {
      if( ! fgets(sBuffer, 128, fPtr) )
	break;

      TOOLS_removeNR (sBuffer);

      /*Router vers utilisateur local ou remote ?*/
      if( Remote == DB_LOCAL )
	BUFFERS_printBuff(nUserStream, OUT, "%s\n", sBuffer);
      else
	PROTOCOL_dbResponse(0, szServer, DATABASE_pszRemoteDB_FromPC,
			    nUserStream, sBuffer);
    }/*End FOR*/

    /*Fermer le fichier*/
    fclose (fPtr);

  }/*End IF*/

  //Effacer le fichier temporaire et librer la mmoire
  unlink(pTmpFile);
  free(pTmpFile);

  return ExitCode;
}

/* Executer une commande */
int EXECUTE_command(int StreamNum, char * Cmd, char * Args, char * Path)
{
  struct stat bufstat;
  char	sBuffer[MAXPATH+256];
  char *pTmpFile;
  char  sCmd[256];
  char *pPtr;
  int	ExitCode;
  int	fd;
  int 	nb;

  //Enlever CRLF de la commande
  strcpy(sCmd, Cmd);
  TOOLS_removeNR(sCmd);

  //Remplacer les '/' par des '\'
  pPtr = sCmd;
  while( *pPtr )
  {
    if( *pPtr == '/' )
      *pPtr = '\\';
    pPtr++;
  }

  //Quitter si Cmd commence par un '*' ou un '*' (car stat considre un tel fichier comme existant)
  if( *sCmd == '?' || *sCmd == '*' )
    return -1;

  //Crer le nom du fichier (.EXE)
  sprintf(sBuffer, "%s%s.exe", Path, sCmd);

  //Ce programme existe t-il (.EXE) ?
  if( (stat(sBuffer, &bufstat) == -1) )
  {
    //Peut-tre un .BAT ?
    sprintf(sBuffer, "%s%s.bat", Path, sCmd);

    //Ce programme existe t-il (.BAT) ?
    if( (stat(sBuffer, &bufstat) == -1) )
      return -1;
  }

  //Le fichier existe - Ajouter les arguments
  strcat(sBuffer, " ");
  strcat(sBuffer, Args);

  //Prparer le fichier temporaire
  pTmpFile = tempnam("/tmp", "dx");

  //Excuter la commande
  ExitCode = EXECUTE_dos(sBuffer, pTmpFile);

  if( ExitCode == 127 )
    ExitCode = -1;

  //Renvoyer le retour  l'utilisateur
  if( (ExitCode) >= 0 && (fd = open(pTmpFile, O_RDONLY)) != 0 )
  {
    for(;;)
    {
      nb = read(fd, sBuffer, 250);
      if( nb <= 0 )
	break;
      BUFFERS_addBuff_sized(StreamNum, sBuffer, OUT, nb);
    }
  }

  close( fd );

  //Effacer le fichier temporaire et librer la mmoire
  unlink(pTmpFile);
  free(pTmpFile);

  return ExitCode;
}

//---------------------------------------------------------------------------
//------ Excuter la commande DOS -------------------------------------------
//---------------------------------------------------------------------------
int EXECUTE_dos(char * Cmd, char * Out)
{
  char *argv[34];
  int	fd;
  int	oldstdout;
  int	exitcode;

  //Isoler les arguments
  argv[0] = getenv("COMSPEC");
  argv[1] = "/C";
  parse_args(argv+2, Cmd);

  //??
  if( strstr(argv[0], "..") )
    return -1;

  //Vrifier que le fichier temporaire peut-tre ouvert
  fd = open(Out, O_CREAT | O_RDWR, S_IREAD|S_IWRITE);
  if( fd < 0 )
    return 1;

  //Dupliquer un handle pour la sortie standard
  oldstdout = dup( STDOUT );

  //Rediriger la sortie standard
  dup2(fd, STDOUT);

  //Fermer le handle
  close( fd );

  //Excuter la commande
  if( strstr(argv[2], ".bat") )
    exitcode = spawnv(P_WAIT, argv[0], argv);		//Fichier BATCH
  else
    exitcode = spawnv(P_WAIT, argv[2], argv + 2);	//Fichier EXE

  //Restaurer le handle d'origine et fermer le fichier
  dup2(oldstdout, STDOUT);
  close (oldstdout); 	//Ne pas oublier de fermer ce fichier la !!!

  //Retourner
  return exitcode;
}

//---------------------------------------------------------------------------
//---- These functions are straight from NOS --------------------------------
//---------------------------------------------------------------------------
char *EXECUTE_parse_string(char *str)
{
	char *cp = str;
	unsigned long num;

	while (*str != '\0' && *str != '\"') {
		if (*str == '\\') {
			str++;
			switch (*str++) {
			case 'n':
				*cp++ = '\n';
				break;
			case 't':
				*cp++ = '\t';
				break;
			case 'v':
				*cp++ = '\v';
				break;
			case 'b':
				*cp++ = '\b';
				break;
			case 'r':
				*cp++ = '\r';
				break;
			case 'f':
				*cp++ = '\f';
				break;
			case 'a':
				*cp++ = '\007';
				break;
			case '\\':
				*cp++ = '\\';
				break;
			case '\"':
				*cp++ = '\"';
				break;
			case 'x':
				num = strtoul(--str, &str, 16);
				*cp++ = (char) num;
				break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
				num = strtoul(--str, &str, 8);
				*cp++ = (char) num;
				break;
			case '\0':
				return NULL;
			default:
				*cp++ = *(str - 1);
				break;
			};
		} else {
			*cp++ = *str++;
		}
	}
	if (*str == '\"')
		str++;		/* skip final quote */
	*cp = '\0';		/* terminate string */
	return str;
}

int parse_args(char **argv, char *cmd)
{
	int ct = 0;
//	int quoted;

	while (ct < 31)
	{
//		quoted = 0;
		while (*cmd && isspace(*cmd))
			cmd++;
		if (*cmd == 0)
			break;
//		if (*cmd == '"') {
//			quoted++;
//			cmd++;
//		}
		argv[ct++] = cmd;
//		if (quoted) {
//			if ((cmd = parse_string(cmd)) == NULL)
//				return 0;
//		} else {
			while (*cmd && !isspace(*cmd))
				cmd++;
//		}
		if (*cmd)
			*cmd++ = 0;
	}
	argv[ct] = NULL;
	return ct;
}
